var globals = null;

var myObserver = {
  observe: function(subject,topic,data) {
    switch (topic) {
      case "ext:delicious:defaultUserChanged":
        clearList("delicious-tags-list");
        loadTags();
        break;
    }
  }
};

function clearList(listID)
{
  var list = document.getElementById(listID);
  var parent = list.parentNode;
  parent.removeChild(list);

  list = document.createElement("listbox");
  list.setAttribute("flex", "1");
  list.setAttribute("id", "delicious-tags-list");
  list.setAttribute("ondblclick", "return loadSelectedTag();");
  parent.insertBefore(list, document.getElementById("delicious-tags-allusers"));
}

function onLoad()
{
  globals = window.arguments[1];
  loadTags();

  var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  observerService.addObserver(myObserver,"ext:delicious:defaultUserChanged",false);
  window.onunload = function() {
    observerService.removeObserver(myObserver,"ext:delicious:defaultUserChanged");
  };
}

/**
 * Loads tags into a list
 */
function loadTags()
{
    const tagsList = document.getElementById('delicious-tags-list');
	const xmlDOM = new DOMParser().parseFromString(globals.userManager.getDefaultUser().tags.asXml(true), "text/xml");
    
    var root = xmlDOM.documentElement;
    var myTags = root.getElementsByTagName("tag");
        
    for (var i = 0; i < myTags.length; i++) 
    {
        var tagName = myTags[i].getAttribute("tag");
        tagsList.appendItem(tagName, tagName);
    }
}

/**
 * Displays the selected tags
 */
function loadSelectedTag()
{
    const tagsList = document.getElementById('delicious-tags-list');

    if(tagsList.selectedCount == 0)
    {
        alert("No tag selected to display");
        return false;
    }
    else
    {
    	globals.deliciousService.showSelectedTag(
    		tagsList.selectedItem.value,
    		document.getElementById("delicious-tags-allusers").checked, 
    		window.arguments[0]._content);
    }
}
